package nl.niftysystems.android.xboxlivestatswidget;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;


public class XMLHandler extends DefaultHandler{

     // ===========================================================
     // Fields
     // ===========================================================
     
     private boolean in_xboxinfo = false;
     private boolean in_presenceinfo = false;
     private boolean in_info = false;
     private boolean in_online = false;
     private boolean in_gamertag = false;
     private boolean in_tileurl = false;
     private boolean in_gamerscore = false;
     private boolean in_recentgames = false;
     
     private ParsedDataSet parsedDataSet = new ParsedDataSet();

     // ===========================================================
     // Getter & Setter
     // ===========================================================

     public ParsedDataSet getParsedData() {
          return this.parsedDataSet;
     }

     // ===========================================================
     // Methods
     // ===========================================================
     @Override
     public void startDocument() throws SAXException {
          this.parsedDataSet = new ParsedDataSet();
     }

     @Override
     public void endDocument() throws SAXException {
          // Nothing to do
     }

     /** Gets be called on opening tags like:
      * <tag>
      * Can provide attribute(s), when xml was like:
      * <tag attribute="attributeValue">*/
     @Override
     public void startElement(String namespaceURI, String localName,
               String qName, Attributes atts) throws SAXException {
          if (localName.equals("XboxInfo")) {
               this.in_xboxinfo = true;
          }else if (localName.equals("PresenceInfo")) {
               this.in_presenceinfo = true;
          }else if (localName.equals("Info")) {
               this.in_info = true;
          }else if (localName.equals("Online")) {
               this.in_online = true;
          }else if (localName.equals("Gamertag")) {
               this.in_gamertag = true;
          }else if (localName.equals("TileUrl")) {
               this.in_tileurl = true;
          }else if (localName.equals("GamerScore")) {
               this.in_gamerscore = true;
          }else if (localName.equals("RecentGames")) {
               this.in_recentgames = true;
          }
     }
     
     /** Gets be called on closing tags like:
      * </tag> */
     @Override
     public void endElement(String namespaceURI, String localName, String qName)
               throws SAXException {
          if (localName.equals("XboxInfo")) {
               this.in_xboxinfo = false;
          }else if (localName.equals("PresenceInfo")) {
               this.in_presenceinfo = false;
          }else if (localName.equals("Info")) {
               this.in_info = false;
          }else if (localName.equals("Online")) {
               this.in_online = false;
          }else if (localName.equals("Gamertag")) {
               this.in_gamertag = false;
          }else if (localName.equals("TileUrl")) {
               this.in_tileurl = false;
          }else if (localName.equals("GamerScore")) {
               this.in_gamerscore = false;
          } else if (localName.equals("RecentGames")) {
               this.in_recentgames = false;
          }
     }
     
     /** Gets be called on the following structure:
      * <tag>characters</tag> */
     @Override
    public void characters(char ch[], int start, int length) {
          if(this.in_info) {
        	  parsedDataSet.setGamerInfo(new String(ch, start, length));
          }
          if(this.in_online) {
        	  parsedDataSet.setOnline(new String(ch, start, length));
          }
          if(this.in_gamertag) {
              parsedDataSet.setGamertag(new String(ch, start, length));
          }
          if(this.in_tileurl) {
        	  parsedDataSet.setTileUrl(new String(ch, start, length));
          }
          if(this.in_gamerscore && !this.in_recentgames) {
        	  parsedDataSet.setGamerScore(new String(ch, start, length));
          }
    }
}